<?
/** --------------------------------------------------------------------------------------------
* This script is part of the IPS Harmony_XMPP package and needs the Harmony_XMPP.ips.php library
* to run. It acts as an XMPP client responding to the Harmony Hub XMPP Server.
*
* The first step (step 1) for the initialization of a command consists in calling Harmony_init().
* This needs to be called from outside this script (e.g. Harmony_Control.ips.php script).
* Subsequent steps are then handled by this script.
*
* V0.6 - 06/03/2014
* by Zapp for the IP-Symcon community.
*/
// ---------------------------------------------------------------------------------------------
include("Harmony_XMPP.ips.php");

$debug = true;

$xml	= $_IPS['VALUE'];

preg_match('/<([a-z:]+)\s/', $xml, $tag); 

switch($tag[1]) {
   case 'iq':
		Harmony_processIQ($xml); // Step 5 - Received IQ message for bind response (see function for further steps)
		break;
	case 'message':
      $content = XMPP_getPayload($xml);
      if ($content['type'] == "startActivityFinished") {
         $activity = Harmony_getActivityFromId($content['activityId']);
         IPS_LogMessage("HARMONY XMPP", "Activity $activity started");
         Harmony_setActivityVariable($content['activityId']);
      }
		break;
	case 'stream:stream':
	   if ($debug) IPS_LogMessage("HARMONY XMPP", "RECV: STREAM Confirmation received\r\n");
      preg_match('/id=\'([a-zA-Z0-9-_]+)\'\s/', $xml, $id);
		IPS_LogMessage("HARMONY XMPP", " -> id: ".$id[1]);
      if (!strpos($xml, "<bind")) {
         // Step 2 - Received stream response: mechanism feature advertisement. We authenticate.
         Harmony_processAuth();
		} else {
		   // Step 4 - Received stream response: resource binding feature advertisement
		   $resource = $HARMONY_CLIENT_RESOURCE;
		   XMPP_Bind($resource);   // Now bind a resource (defined in library)
		}
		//print_r($xml);
	   break;
	case 'success':
	   if ($debug) IPS_LogMessage("HARMONY XMPP", "RECV: Authentication SUCCESS\r\n");
	   XMPP_OpenStream(); // Step 3 - Open  new stream for binding
	   break;
   case 'failure':
	   if ($debug) IPS_LogMessage("HARMONY XMPP", "RECV: Authentication FAILED\r\n");
	   break;
	default:
	   // We suppose that if there is no XMPP tag, we received a contination of an OA message and have to aggregate.
	   Harmony_processIQ($xml);
	   break;
}

//print_r($content);



?>
